
from LIB.MIDDLE.FaultDetection.V1_0_1.CoreAlgo.aelstm import *
import pymysql
import datetime
import pandas as pd
from LIB.BACKEND import DBManager
dbManager = DBManager.DBManager()
from sqlalchemy import create_engine
from urllib import parse
import datetime, time
from apscheduler.schedulers.blocking import BlockingScheduler
from LIB.MIDDLE.CellStateEstimation.Common import log
import traceback
import pickle
from keras.models import load_model


#...................................故障检测函数......................................................................................................................
def diag_cal():
    global SNnums

    start=time.time()
    now_time=datetime.datetime.now()
    start_time=now_time-datetime.timedelta(hours=3)
    start_time=start_time.strftime('%Y-%m-%d %H:%M:%S')
    end_time=now_time.strftime('%Y-%m-%d %H:%M:%S')

    #数据库配置
    host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port=3306
    db='safety_platform'
    user='qx_read'
    password='Qx@123456'

    #读取结果库数据......................................................
    param='product_id,start_time,end_time,diff_min,SOC[%],AnoScoreV_sum_max,AnoScoreV_max_max,AnoScoreT_sum_max,AnoScoreT_max_max'
    tablename='fault_detection'
    mysql = pymysql.connect (host=host, user=user, password=password, port=port, database=db)
    cursor = mysql.cursor()
    sql =  "select %s from %s where time_end='0000-00-00 00:00:00'" %(param,tablename)
    cursor.execute(sql)
    res = cursor.fetchall()
    df_diag_ram= pd.DataFrame(res,columns=param.split(','))
    

    db_res_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, parse.quote_plus(password), host, port, db
        ))

    mylog=log.Mylog('log_info_charge.txt','error')
    mylog.logcfg()


    #调用主函数................................................................................................................................................................
    for sn in SNnums:
        try:
            group=sn[:5]
            df_data = dbManager.get_data(sn=sn, start_time=start_time, end_time=end_time, data_groups=['bms'])
            data_bms = df_data['bms']
            data_bms['sn']=sn
            if len(data_bms)>0:
                data_stand=data_groups(data_bms,sn,start_time,end_time)
                df_stand=split(data_stand)   
                res=pd.DataFrame()
                if len(df_stand)>0:
                    #读取训练产出的缩放指标：均值&方差
                    scaler = pickle.load(open('D:/Develop/User/Zhuxi/data_analyze_platform/LIB/MIDDLE/FaultDetection/V1_0_2/train_out/scalerV_'+group+'_10.pkl', 'rb'))
                    scaler2 = pickle.load(open('D:/Develop/User/Zhuxi/data_analyze_platform/LIB/MIDDLE/FaultDetection/V1_0_2/train_out/scalerT_'+group+'_10.pkl', 'rb'))
                    #读取训练产出的模型状态空间：电压模型&温度模型
                    model = load_model('D:/Develop/User/Zhuxi/data_analyze_platform/LIB/MIDDLE/FaultDetection/V1_0_2/train_out/modelV_'+group+'_10.h5')
                    model2 = load_model('D:/Develop/User/Zhuxi/data_analyze_platform/LIB/MIDDLE/FaultDetection/V1_0_2/train_out/modelT_'+group+'_10.h5')
                    res=prediction(df_stand,scaler,scaler2,model,model2)
                    if len(res)>0:
                        df_res2,diff=threshold(res,group,end_time)
                        df_diag_ram_sn=pd.Series()
                        if not df_diag_ram.empty:   #结果库非空
                            df_diag_ram_sn=df_diag_ram[df_diag_ram['sn']==sn]
                            if not df_diag_ram_sn.empty:   #该sn相关结果非空
                                new_res,update_res=arrange(df_res2,df_diag_ram_sn,start_time,diff)
                                if len(update_res)>0:
                                    cursor.execute("DELETE FROM fault_detection WHERE time_end = '0000-00-00 00:00:00' and sn='{}'".format(sn))
                                    mysql.commit()
                                    update_res.to_sql("fault_detection",con=db_res_engine, if_exists="append",index=False)
                                #新增结果存入结果库................................................................
                                if len(new_res)>0:
                                    new_res.to_sql("fault_detection",con=db_res_engine, if_exists="append",index=False)

            end=time.time()
            print(end-start)  
                
        except Exception as e:
            print(repr(e))
            mylog.logopt(e)

    cursor.close()
    mysql.close()

#...............................................主函数起定时作用.......................................................................................................................
if __name__ == "__main__":
    
    #excelpath=r'D:\Platform\platform_python\data_analyze_platform\USER\spf\01qixiang\sn-20210903.xlsx'
    excelpath='sn-20210903.xlsx'
    dataSOH = pd.read_excel('sn-20210903.xlsx',sheet_name='sn-20210903')
    SNnums = list(dataSOH['sn'])
    
    mylog=log.Mylog('log_info_charge.txt','error')
    mylog.logcfg()

    diag_cal()
    #定时任务.......................................................................................................................................................................
    scheduler = BlockingScheduler()
    scheduler.add_job(diag_cal, 'interval', hours=3)

    try:  
        scheduler.start()
    except Exception as e:
        scheduler.shutdown()
        print(repr(e))
        mylog.logopt(e)