from ctypes import Structure
from re import M
import pandas as pd
import numpy as np
import datetime
import time, datetime
import matplotlib.pyplot as plt
from pylab import*
from scipy.signal import savgol_filter
from scipy import interpolate
import os
import log
from LIB.MIDDLE.SaftyCenter.Common import QX_BatteryParam as BatParam

class chrgrsoc_test:
    def __init__(self,sn,celltype,df_bms):  #参数初始化

        self.sn=sn
        self.celltype=celltype
        self.param=BatParam.BatteryInfo(celltype)#鹏飞param中为BatParam，学琦为BatteryInfo
        self.df_bms=pd.DataFrame(df_bms)
        self.packcrnt=df_bms['总电流[A]']*self.param.PackCrntDec
        self.packvolt=df_bms['总电压[V]']
        self.bms_soc=df_bms['SOC[%]']
        self.bmstime= pd.to_datetime(df_bms['时间戳'], format='%Y-%m-%d %H:%M:%S')
        self.LookTab_SOC = self.param.LookTab_SOC
        self.LookTab_OCV = self.param.LookTab_OCV

        self.cellvolt_name=['单体电压'+str(x) for x in range(1,self.param.CellVoltNums+1)]
        self.celltemp_name=['单体温度'+str(x) for x in range(1,self.param.CellTempNums+1)]
        self.bmssta = df_bms['充电状态']
    #定义加权滤波函数..................................................................................................
    def moving_average(interval, windowsize):
        window = np.ones(int(windowsize)) / float(windowsize)
        re = np.convolve(interval, window, 'same')
        return re
#.............................................充电截止SOC............................................................................
    def chrgrsoc_detect(self):
        data = self.df_bms
        chrgr_soc = pd.DataFrame()
        if len(data) > 1:
            df_soc = data['SOC[%]']
            df_soc_len = len(df_soc)
            df_soc_add = df_soc.iloc[df_soc_len-3:df_soc_len-1]#由于对SOC二次微分，增加两行数据
            df_soc_new = df_soc.append(df_soc_add)
            df_soc_new_dif = np.diff(df_soc_new,axis=0)#电压一次微分，判断升降
            df_soc_new_dif = pd.DataFrame(df_soc_new_dif)
            df_soc_new_dif[df_soc_new_dif > 0] = 1#SOC升高
            df_soc_new_dif[df_soc_new_dif == 0] = 0#SOC升高或静置
            df_soc_new_dif[df_soc_new_dif < 0] = -1#SOC下降
            df_soc_dif_arr = np.array(df_soc_new_dif)
            pos_change = nonzero(df_soc_dif_arr)#寻找非零元素位置
            value_change = df_soc_dif_arr[pos_change[0]]#非零元素数值
            value_change_dif = np.diff(value_change)#对非零元素值二次微分
            peak_pos = np.where(value_change_dif == -2)#充电结束点
            bot_pos = np.where(value_change_dif == 2)#放电结束点
            #-------------------------------------------------------利用soc的升降判断充放电---------------------------------------------------------
            pos_change_dif = np.diff(pos_change[0])#计算SOC变化时的位置信息
            pos_change_del_temp = np.where(pos_change_dif < 10)
            pos_change_del = pos_change_del_temp[0] + 1
            value_change_new = np.delete(value_change[:,0], pos_change_del)#SOC发生变化数值
            pos_change_new = np.delete(pos_change[0], pos_change_del)#SOC发生变化位置
            value_change_new_dif = np.diff(value_change_new)#寻找充电或放电结束位置
            value_change_new_dif = np.insert(value_change_new_dif, 0, value_change_new_dif[0])
            chrgr_dischrgr_pos_temp = np.where(abs(value_change_new_dif) == 2)#寻找充电或放电结束位置
            splice_num = []
            if len(chrgr_dischrgr_pos_temp[0]) >= 1:
                chrgr_dischrgr_pos = pos_change_new[chrgr_dischrgr_pos_temp[0]]#原数据中充电或放电结束位置
                chrgr_dischrgr_pos = np.insert(chrgr_dischrgr_pos, 0, 0)
                data_len = len(df_soc)#数据长度
                pos_len = len(chrgr_dischrgr_pos)#切片长度
                chrgr_dischrgr_pos = np.insert(chrgr_dischrgr_pos, pos_len, data_len-1)#
                for item in range(0,len(chrgr_dischrgr_pos)-1):
                    splice_num.extend(item*np.ones(chrgr_dischrgr_pos[item +1]-chrgr_dischrgr_pos[item]))
                splice_num = np.insert(splice_num, data_len-2, item)
            else:
                splice_num = np.zeros(len(df_soc))
                # pos_ful = np.array([0])
            data['stat'] = splice_num
            #--------------------------------------------------------筛选充电数据与放电数据-------------------------------------
            chrgr_data = pd.DataFrame()
            dischrgr_data = pd.DataFrame()
            for num_chrgr in range(0,len(chrgr_dischrgr_pos)-1):
                df_data_temp = data.loc[(data['stat'] == num_chrgr)]
                data_splice_len = len(df_data_temp)
                if np.count_nonzero(df_data_temp['总电流[A]'] > 0) > 0.3*data_splice_len:
                    chrgr_data_temp = df_data_temp.loc[df_data_temp['总电流[A]'] >= 0]#筛选具有充电电流的充电数据
                    chrgr_data = chrgr_data.append(chrgr_data_temp)
                    chrgr_data = chrgr_data.reset_index(drop = True)
                else:
                    dischrgr_data_temp = df_data_temp.loc[df_data_temp['总电流[A]'] <= 0]#筛选具有放电电流的放电数据
                    dischrgr_data = dischrgr_data.append(dischrgr_data_temp)
                    dischrgr_data = dischrgr_data.reset_index(drop = True)
            if len(chrgr_data) > 1:
                chrgr_num_difference = np.unique(chrgr_data['stat'])
                #--------------------------------------------------------统计充电截止电压、充电SOC区间---------------------------------------------------------

                cell_name = ['单体电压'+str(x) for x in range(1,21)]#电芯电压名称
                chrgr_volt = pd.DataFrame()
                chrgr_fin_volt = pd.DataFrame()
                
                f = interpolate.interp1d(self.LookTab_OCV, self.LookTab_SOC, kind = 'quadratic')#差值函数
                for chrgr_num in chrgr_num_difference:
                    data_temp = chrgr_data.loc[chrgr_data['stat'] == chrgr_num]#该片段数据
                    chrgr_crnt_data = data_temp.loc[data_temp['总电流[A]'] > 0]#充电数据中有电流部分，充电时电流为正
                    chrgr_crnt_data = chrgr_crnt_data.reset_index(drop = True)
                    chrgr_crnt_zero_before = data_temp.loc[data_temp['时间戳'] < chrgr_crnt_data['时间戳'][0]]#充电数据中出现电流前数据
                    chrgr_crnt_zero_after = data_temp.loc[data_temp['时间戳'] > chrgr_crnt_data.iloc[-1]['时间戳']]#充电数据中出现电流前数据
                    chrgr_crnt_zero_before = chrgr_crnt_zero_before.reset_index(drop = True)
                    chrgr_crnt_zero_after = chrgr_crnt_zero_after.reset_index(drop = True)
                    time_before = pd.to_datetime(chrgr_crnt_zero_before['时间戳'])
                    time_after = pd.to_datetime(chrgr_crnt_zero_after['时间戳'])
                    chrgr_rest_len = len(time_after)
                    if chrgr_rest_len > 1:
                        if (time_after[chrgr_rest_len - 1] - time_after[0])/pd.Timedelta(1, 'min') > 10:
                            # chrgr_volt = chrgr_volt.append(chrgr_crnt_zero_before.iloc[-1])#充电开始前静置电压
                            chrgr_volt = chrgr_volt.append(chrgr_crnt_zero_after.iloc[-1])#充电结束静置电压
                for cell_num in cell_name:#获取各个电芯充电结束后的SOC
                    chrgr_cellsoc = f(chrgr_volt[cell_num]/1000)
                    chrgr_cellsoc_temp = pd.DataFrame(chrgr_cellsoc)
                    chrgr_soc = pd.concat([chrgr_soc, chrgr_cellsoc_temp], axis = 1)#按列合并各个电芯
                chrgr_soc = chrgr_soc.reset_index(drop = True)
                chrgr_soc.columns = cell_name
                chrgr_soc['time'] = list(chrgr_volt['时间戳'])
                chrgr_soc['stat'] = list(chrgr_volt['stat'])
                chrgr_soc['soc_delta'] =  np.max(chrgr_soc[cell_name], axis = 1) - np.min(chrgr_soc[cell_name], axis = 1)
                chrgr_soc['sn'] = self.sn
    #返回诊断结果...........................................................................................................
        if not chrgr_soc.empty:
            return chrgr_soc
        else:
            return pd.DataFrame()